<template>
  <single-pane :capt="dictionaryRu.caption">
    <ob-table
      :items="functionsList"
      :columns="columnsObTable"
      :functional-panel="true"
      @select="openPopup"
    />
    <ob-modal
      ref="editModal"
      size="sm"
      :title="dictionaryRu.modal.title"
    >
      <function-edit
        :data-source="selectedData"
        :available-roles="roles"
        @close="closeEditPopup"
        @save="onEditSave"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import moment       from 'moment';
import cloneDeep    from 'clone-deep';
import api          from '@/api';

import SinglePane     from 'common-components/src/obComponents/obSinglePanels';
import ObTable        from 'common-components/src/obComponents/obTable';
import ObModal        from 'common-components/src/obComponents/obModal';
import FunctionEdit   from './modal/FunctionEdit';
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary } from '@/translations/ru/settings__admin__access'

const iconOrder = {
  administrator: 0,
  moderator    : 1,
  expeditor    : 2,
  client       : 3,
  carrier      : 4,
  agent        : 5,
  guest        : 6
}

export default {
  name: 'Access',
  components: {
    ObModal,
    FunctionEdit,
    ObTable,
    SinglePane
  },
  data () {
    return {
      iconOrder,
      isEditOpen: false,
      selectedData: {},
      functionsList: [],
      showControls: true,
      roles: [],
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  computed: {
    columnsObTable () {
      return [
        {
            title: this.dictionaryRu.columns.title,
            key: 'title',
            width: 'auto'
        },
        {
            title: this.dictionaryRu.columns.type,
            key: 'type_title',
            width: 'auto'
        },
        {
            title: this.dictionaryRu.columns.C,
            key: 'has_create_access',
            html: ({ has_create_access }) => has_create_access ? 'C' : '',
            width: 70,
        },
        {
            title: this.dictionaryRu.columns.R,
            key: 'has_read_access',
            html: ({ has_read_access }) => has_read_access ? 'R' : '',
            width: 70,
        },
        {
            title: this.dictionaryRu.columns.U,
            key: 'has_update_access',
            html: ({ has_update_access }) => has_update_access ? 'U' : '',
            width: 70,
        },
        {
            title: this.dictionaryRu.columns.D,
            key: 'has_delete_access',
            html: ({ has_delete_access }) => has_delete_access ? 'D' : '',
            width: 70,
        },
        {
            title: this.dictionaryRu.columns.E,
            key: 'has_execute_access',
            html: ({ has_execute_access }) => has_execute_access ? 'E' : '',
            width: 70,
        },
        {
            title: this.dictionaryRu.columns.roleTitle,
            key: 'contractor_role_codes',
            html: ({ contractor_role_codes }) => this.contractorRolesCol(contractor_role_codes),
        },
        {
            title: this.dictionaryRu.columns.status,
            key: 'is_active',
            html: ({ is_active }) => is_active
              ? this.dictionaryRu.statusValue.active
              : this.dictionaryRu.statusValue.inactive
        },
        {
            title: this.dictionaryRu.columns.createdAt,
            key: 'first_release_dt',
            width: 'auto',
            html: ({ first_release_dt }) => first_release_dt
              ? moment(first_release_dt).format('DD.MM.YYYY')
              : ''
        },
        {
            title: this.dictionaryRu.columns.lastReleaseDate,
            key: 'last_release_dt',
            width: 'auto',
            html: ({ last_release_dt }) => last_release_dt
              ? moment(last_release_dt).format('DD.MM.YYYY')
              : ''
        }
      ]
    },
  },
  watch: {
    // TODO
    '$store.getters.getCurrentLocale' () {
      this.onLoadData()
    }
  },
  mounted () {
    this.onLoadData()
  },
  methods: {
    onLoadData () {
      api.adminPanel.adminPanelAccess.getFunctions().then((data) => {
        this.functionsList = data
      }).catch((e) => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      })
      api.adminPanel.adminPanelRoles.getContractorRoles().then(roles => {
        this.roles = roles
      }).catch((e) => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      })
    },
    getCrudName (item, isShort) {
      for (let i of this.crudOption) {
        if (item.column.dataField === i.props) {
          if (item.data[i.props]) {
            if (isShort) return i.short
            return i.title
          }
        }
      }
    },
    getContractorRoleCodes (roles) {
      const _roles = cloneDeep(roles);
      const compare = (a, b) => {
        if ( this.iconOrder[a] < this.iconOrder[b] ) return -1;

        return 0;
      }

      return _roles.sort(compare)
    },
    getCodeToTitleMap(role) {
      const _obj = this.roles.find(obj => {
        return obj.code === role
      });

      return _obj ? _obj.title : '';
    },
    getIconClassByRole (role) {
      const iconMap = {
        administrator: 'administrator',
        moderator    : 'system-moderator',
        expeditor    : 'domain-owner',
        client       : 'client',
        carrier      : 'carrier',
        agent        : 'agent',
        anonymous    : 'profile'
      }

      return `role-${iconMap[role] || iconMap.anonymous}`
    },
    openPopup (data) {
      if (!data) return;

      this.selectedData = data;
      this.$refs.editModal.open()
    },
    closeEditPopup (isUpdate) {
      this.$refs.editModal.close();
      this.selectedData = {};

      if (isUpdate) this.onLoadData();
    },
    onEditSave (event) {
      const methods = [];

      if (event.is_active !== this.selectedData.is_active) {
        methods.push(
          api.adminPanel.adminPanelAccess.setFunctionStatus(
            this.selectedData.uuid, {is_active: event.is_active}
          )
          .catch((e) => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка изменения статуса'
            })
          })
        )
      }

      const removeContractorRoles = this.selectedData.contractor_role_codes.filter(i => (
        !event.contractor_role_codes.includes(i)
      ))
      const findRoleUuids = array => {
        const data = this.roles.map(role => {
          return array.includes(role.code) ? role.uuid : null
        });

        return data.filter(uuid => uuid !== null);
      }

      if (event.contractor_role_codes.length > 0) {
        methods.push(
          api.adminPanel.adminPanelAccess.addContractorRoles(
            this.selectedData.uuid, {
              contractor_roles: findRoleUuids(event.contractor_role_codes)
            }
          )
          .catch((e) => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка добавления роли'
            })
          })
        )
      }

      if (removeContractorRoles.length > 0) {
        methods.push(
          api.adminPanel.adminPanelAccess.removeContractorRoles(
            this.selectedData.uuid, {
              contractor_roles: findRoleUuids(removeContractorRoles)
            }
          )
          .catch((e) => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка удаления роли'
            })
          })
        )
      }

      if (methods.length > 0) {
        const notificationId = `${new Date().getTime()}save`;

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });

        Promise.all(methods)
          .then(() => {
            this.closeEditPopup(true);
            this.$notification({
              type: 'system_notification_success',
              message: 'Доступ сохранен'
            })
          })
          .finally(() => {
            this.$notification({
              event: 'close',
              id: notificationId
            })
          })
      }
    },
    contractorRolesCol(roles){
      const rls = this.getContractorRoleCodes(roles);

      const icon = rls.map((item, idx) => {
        return `<i class="icon ${this.getIconClassByRole(rls[idx])} -cobalt" style="font-size: 21px"></i>`;
      });

      return `<nobr>${icon.join('')}</nobr>`;
    }
  }
}
</script>

<style lang="scss" scoped>
  .icon-panel__item {
    display: inline-block;
    margin-right: 15px;

    &:last-of-type {
      margin-right: 0;
    }
  }
</style>
